unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, KDaoTable, KDaoDataBase, ComCtrls, KADaoDBTreeView, Grids,
  DBGrids, StdCtrls, Mask, DBCtrls, ExtCtrls, ImgList, KADaoDBGrid,
  KADaoDBColumnListBox;

type
  TForm1 = class(TForm)
    KADaoDatabase1: TKADaoDatabase;
    KADaoDBTreeView1: TKADaoDBTreeView;
    DBEdit1: TDBEdit;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    ImageList: TImageList;
    DataSource1: TDataSource;
    KADaoTable1: TKADaoTable;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    KADaoDBGrid1: TKADaoDBGrid;
    CheckBox1: TCheckBox;
    procedure KADaoDBTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Button1Click(Sender: TObject);
    procedure KADaoDBTreeView1GetImageIndex(Sender: TObject;
      Node: TTreeNode);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.KADaoDBTreeView1Change(Sender: TObject; Node: TTreeNode);
Var
  NR : TNodeRecord;
  FF  : TField;
begin
  NR := KADaoDBTreeView1.GetNodeData(Node);
  if Assigned(NR.Fields) Then
     FF := NR.Fields.FieldByName('OtherData');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 KADaoDBTreeView1.ReBuildTree;
end;

procedure TForm1.KADaoDBTreeView1GetImageIndex(Sender: TObject;  Node: TTreeNode);
Var
 NR : PNodeRecord;
 S  : String;
begin
  NR := PNodeRecord(Node.Data);
  if NR=Nil Then Exit;
  //****************************************************************************
  // Example how to get value of a cached field
  //****************************************************************************
  S := NR^.CachedFields.Values['OtherData'];
  //****************************************************************************
  if Node.Count > 0 Then
    Node.ImageIndex := 4
  Else
    Node.ImageIndex := Node.Level;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  KADaoDBTreeView1.PositionUp(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  KADaoDBTreeView1.PositionDown(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  KADaoDBTreeView1.LevelUp(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 KADaoDBTreeView1.LevelDown(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  KADaoDBTreeView1.RebuildDataset;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  KADaoDBTreeView1.AddEmptyNode(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  KADaoDBTreeView1.DeleteNode(KADaoDBTreeView1.Selected);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   if KaDaoTable1.Find_Next('ID',16,[]) Then ShowMessage('Found at pos: '+IntTostr(KaDaoTable1.RecNo));
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 KADaoDBTreeView1.Db_ShowRootParent := CheckBox1.Checked;
end;

end.
